`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    19:01:02 11/16/2016 
// Design Name: 
// Module Name:    ms_board 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module ms_board(
	clk, reset, restart, swap, up, down, left, right, click, curx, cury,
	actx, acty, curstate, dead, finished
    );
	input clk, reset, restart, swap, up, down, left, right, click;
	input [4:0] curx, cury;
	output [3:0] actx, acty;
	output dead, finished;
	output [3:0] curstate;
	reg [3:0] actx, acty;
	reg mines [0:15][0:15];
	reg clicked [0:15][0:15];
	reg [3:0] cnt [0:15][0:15];
	reg dead, finished;
	
	wire [31:0] ran;
	wire [3:0] ranx1 = ran[30:27];
	wire [3:0] rany1 = ran[26:23];
	wire [3:0] ranx2 = ran[22:19];
	wire [3:0] rany2 = ran[18:15];
	reg next;
	
	ms_rand rand(.clk(clk), .reset(reset), .val(ran), .next(next));
	
	always @ (posedge clk)
		begin : MAIN_LOOP
			integer i, j;
			next <= 0;
			if (reset || restart)
				begin
					for (i = 0; i < 16; i = i+1)
						for (j = 0; j < 16; j = j+1)
							begin
								mines[i][j] <= (i < 5) && (j < 8);
								clicked[i][j] = 0;
							end
					actx <= 7;
					acty <= 7;
				end
			else
				begin
					if (up)
						acty <= acty-1;
					if (down)
						acty <= acty+1;
					if (left)
						actx <= actx-1;
					if (right)
						actx <= actx+1;
					if (swap)
						begin
							next <= 1;
							mines[ranx1][rany1] <= mines[ranx2][rany2];
							mines[ranx2][rany2] <= mines[ranx1][rany1];
						end
						
					for (i = 0; i < 16; i = i+1)
						for (j = 0; j < 16; j = j+1)
							cnt[i][j] = 0;

					for (i = 0; i < 15; i = i+1)
						for (j = 0; j < 16; j = j+1)
							cnt[i][j] = cnt[i][j]+mines[i+1][j];
					for (i = 0; i < 16; i = i+1)
						for (j = 0; j < 15; j = j+1)
							cnt[i][j] = cnt[i][j]+mines[i][j+1];
					for (i = 1; i < 16; i = i+1)
						for (j = 0; j < 16; j = j+1)
							cnt[i][j] = cnt[i][j]+mines[i-1][j];
					for (i = 0; i < 16; i = i+1)
						for (j = 1; j < 16; j = j+1)
							cnt[i][j] = cnt[i][j]+mines[i][j-1];

					for (i = 0; i < 15; i = i+1)
						for (j = 0; j < 15; j = j+1)
							cnt[i][j] = cnt[i][j]+mines[i+1][j+1];
					for (i = 1; i < 16; i = i+1)
						for (j = 0; j < 15; j = j+1)
							cnt[i][j] = cnt[i][j]+mines[i-1][j+1];
					for (i = 0; i < 15; i = i+1)
						for (j = 1; j < 16; j = j+1)
							cnt[i][j] = cnt[i][j]+mines[i+1][j-1];
					for (i = 1; i < 16; i = i+1)
						for (j = 1; j < 16; j = j+1)
							cnt[i][j] = cnt[i][j]+mines[i-1][j-1];
					if (click)
						clicked[actx][acty] = 1;
					for (i = 0; i < 15; i = i+1)
						for (j = 0; j < 16; j = j+1)
							clicked[i][j] = clicked[i][j] || (cnt[i+1][j] == 0 && clicked[i+1][j] && mines[i+1][j] == 0);
					for (i = 0; i < 16; i = i+1)
						for (j = 0; j < 15; j = j+1)
							clicked[i][j] = clicked[i][j] || (cnt[i][j+1] == 0 && clicked[i][j+1] && mines[i][j+1] == 0);
					for (i = 1; i < 16; i = i+1)
						for (j = 0; j < 16; j = j+1)
							clicked[i][j] = clicked[i][j] || (cnt[i-1][j] == 0 && clicked[i-1][j] && mines[i-1][j] == 0);
					for (i = 0; i < 16; i = i+1)
						for (j = 1; j < 16; j = j+1)
							clicked[i][j] = clicked[i][j] || (cnt[i][j-1] == 0 && clicked[i][j-1] && mines[i][j-1] == 0);
					for (i = 0; i < 15; i = i+1)
						for (j = 0; j < 15; j = j+1)
							clicked[i][j] = clicked[i][j] || (cnt[i+1][j+1] == 0 && clicked[i+1][j+1] && mines[i+1][j+1] == 0);
					for (i = 1; i < 16; i = i+1)
						for (j = 0; j < 15; j = j+1)
							clicked[i][j] = clicked[i][j] || (cnt[i-1][j+1] == 0 && clicked[i-1][j+1] && mines[i-1][j+1] == 0);
					for (i = 0; i < 15; i = i+1)
						for (j = 1; j < 16; j = j+1)
							clicked[i][j] = clicked[i][j] || (cnt[i+1][j-1] == 0 && clicked[i+1][j-1] && mines[i+1][j-1] == 0);
					for (i = 1; i < 16; i = i+1)
						for (j = 1; j < 16; j = j+1)
							clicked[i][j] = clicked[i][j] || (cnt[i-1][j-1] == 0 && clicked[i-1][j-1] && mines[i-1][j-1] == 0);
				end
		end
		
		always @ (*)
			begin : UPDATE_DONE
				integer i, j;
				dead = 0;
				for (i = 0; i < 16; i = i+1)
					for (j = 0; j < 16; j = j+1)
						dead = dead || (mines[i][j] && clicked[i][j]);
				finished = 1;
				for (i = 0; i < 16; i = i+1)
					for (j = 0; j < 16; j = j+1)
						finished = finished && (mines[i][j] || clicked[i][j]);
			end
		wire [3:0] truncx = curx[3:0];
		wire [3:0] truncy = cury[3:0];
		wire [3:0] curstate = finished && mines[truncx][truncy] ? 12 :
										clicked[truncx][truncy] ?
											mines[truncx][truncy] ? 12 :
												cnt[truncx][truncy] == 0 ? 10 : cnt[truncx][truncy]
										: 11;

endmodule
