`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    20:41:16 11/17/2016 
// Design Name: 
// Module Name:    ms_display 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module ms_display(
	clk, reset, vga_h_sync, vga_v_sync,
	vga_r0, vga_r1, vga_r2, vga_g0, vga_g1, vga_g2, vga_b0, vga_b1,
	St_ce_bar, St_rp_bar, Mt_ce_bar, Mt_St_oe_bar, Mt_St_we_bar,
	x_quo, y_quo, x_rmd, y_rmd,
	active, b, start, play, won, lost, digit
    );
	input clk, reset;
	output St_ce_bar, St_rp_bar, Mt_ce_bar, Mt_St_oe_bar, Mt_St_we_bar;
	output vga_h_sync, vga_v_sync, vga_r0, vga_r1, vga_r2, vga_g0, vga_g1, vga_g2, vga_b0, vga_b1;
	output [4:0] x_quo, y_quo, x_rmd, y_rmd;
	input active, b, start, play, won, lost;
	input [3:0] digit;
	reg vga_r0, vga_r1, vga_r2, vga_g0, vga_g1, vga_g2, vga_b0, vga_b1;
	assign {St_ce_bar, St_rp_bar, Mt_ce_bar, Mt_St_oe_bar, Mt_St_we_bar} = {5'b11111};
	reg vga_HS, vga_VS;
	wire inDisplayArea;
	wire [9:0] CounterX;
	wire [9:0] CounterY;
	hvsync_generator syncgen(.clk(clk), .reset(reset),.vga_h_sync(vga_h_sync), .vga_v_sync(vga_v_sync), .inDisplayArea(inDisplayArea), .CounterX(CounterX), .CounterY(CounterY));
	wire [4:0] x_quo, y_quo, x_rmd, y_rmd;
	ms_div30 xdiv(.num(CounterX), .quo(x_quo), .rmd(x_rmd));
	ms_div30 ydiv(.num(CounterY), .quo(y_quo), .rmd(y_rmd));
	wire [5:0] smileyx = CounterX-510, smileyy = CounterY-150;
	wire smileface, wowface, deadface, coolface;
	wire eyes = start ? smileface :
								play ? wowface :
								won ? coolface :
								deadface;
	wire face;
	ms_face msface(.x(smileyx), .y(smileyy), .b(face));
	bm_smile smile(.x(smileyx), .y(smileyy), .eyes(smileface));
	bm_wow wow(.x(smileyx), .y(smileyy), .eyes(wowface));
	bm_dead dead(.x(smileyx), .y(smileyy), .eyes(deadface));
	bm_cool cool(.x(smileyx), .y(smileyy), .eyes(coolface));
	wire [7:0] smileycolor = face && eyes == 0 ? 8'b11111100 : 8'b00000000;
	
	wire boundary = (x_rmd == 0 || y_rmd == 0 || x_rmd == 29 || y_rmd == 29) && x_quo < 16;
	wire select = (x_rmd < 4 || y_rmd < 4 || x_rmd >= 26  || y_rmd >= 26) && active;
	wire smiley = (x_quo == 17 || x_quo == 18) && (y_quo == 5 || y_quo == 6);
	
	wire hasDigit = x_quo < 16 || (y_quo == 10 && x_quo != 21);
	
	wire [7:0] digitcolor;
	ms_digitcolor colormap(.digit(digit), .digitcolor(digitcolor));
	wire [7:0] boardcolor = hasDigit == 0 ? 8'b00000000 :
									select ? 8'b11100000 :
									boundary ? 8'b00100101 :
									b ? x_quo < 16 ? digitcolor : 8'b11111111 :
									x_quo < 16 ? 8'b01001001 : 8'b00000000;
	wire [7:0] finalcolor = smiley ? smileycolor : boardcolor;
	
	always @(posedge clk)
	begin
		vga_r0 <= finalcolor[5] & inDisplayArea;
		vga_r1 <= finalcolor[6] & inDisplayArea;
		vga_r2 <= finalcolor[7] & inDisplayArea;
		vga_g0 <= finalcolor[2] & inDisplayArea;
		vga_g1 <= finalcolor[3] & inDisplayArea;
		vga_g2 <= finalcolor[4] & inDisplayArea;
		vga_b0 <= finalcolor[0] & inDisplayArea;
		vga_b1 <= finalcolor[1] & inDisplayArea;
	end
	
endmodule
