`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    18:22:09 11/16/2016 
// Design Name: 
// Module Name:    ms_sm 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module ms_sm(
	clk, reset, up, down, left, right, click, curx, cury,
	start, play, won, lost, actx, acty, curstate
    );
	input clk, reset, up, down, left, right, click;
	input [4:0] curx, cury;
	output start, play, won, lost;
	output [3:0] actx, acty, curstate;
	reg [3:0] state;
	assign {start, play, won, lost} = state;
	wire [3:0] actx, acty, curstate, boardstate;
	wire dead, finished;
	reg [9:0] shuffle_cnt;
	reg [3:0] bcd [0:4];
	reg [11:0] timer;
	assign swap = shuffle_cnt != 0;
	reg restart;
	
	`define QORIG	4'b1000
	`define QPLAY	4'b0100
	`define QWON	4'b0010
	`define QLOST	4'b0001
	assign b_click = click && (shuffle_cnt == 0);
	assign curstate = curx < 16 ? boardstate : bcd[curx-16];
	
	ms_board board(.clk(clk), .reset(reset), .restart(restart), .swap(swap), .up(up), .down(down), .left(left), .right(right), .click(click), .curx(curx), .cury(cury),
		.actx(actx), .acty(acty), .curstate(boardstate), .dead(dead), .finished(finished));
	
	always @ (posedge clk)
		begin : GAME_LOOP
			integer i;
			if (reset)
				begin
					state <= `QORIG;
					shuffle_cnt <= 1000;
					restart <= 1;
					timer <= 0;
					for (i = 0; i < 5; i = i+1)
						bcd[i] <= 0;
				end
			else
				begin
					case (state)
						`QORIG:
							begin
								restart <= 0;
								if (shuffle_cnt != 0)
									shuffle_cnt <= shuffle_cnt-1;
								else
									if (click)
										state <= `QPLAY;		
							end
						`QPLAY:
							begin
								if (timer == 3051)
									begin
										timer <= 0;
										if (bcd[4] == 9)
											begin
												bcd[4] <= 0;
												if (bcd[3] == 9)
													begin
														bcd[3] <= 0;
														if (bcd[2] == 9)
															begin
																bcd[2] <= 0;
																if (bcd[1] == 9)
																	begin
																		bcd[1] <= 0;
																		if (bcd[0] == 9)
																			begin
																				for (i = 0; i < 5; i = i+1)
																					bcd[i] <= 9;
																			end
																		else
																			bcd[0] <= bcd[0]+1;
																	end
																else
																	bcd[1] <= bcd[1]+1;
															end
														else
															bcd[2] <= bcd[2]+1;
													end
												else
													bcd[3] <= bcd[3]+1;
											end
										else
											bcd[4] <= bcd[4]+1;
									end
								else
									timer <= timer+1;
								if (finished)
									state <= `QWON;
								if (dead)
									state <= `QLOST;
							end
						`QWON:
							begin
								if (click)
									begin
										state <= `QORIG;
										shuffle_cnt <= 1000;
										timer <= 0;
										restart <= 1;
										for (i = 0; i < 5; i = i+1)
											bcd[i] <= 0;
									end
							end
						`QLOST:
							begin
								if (click)
									begin
										state <= `QORIG;
										shuffle_cnt <= 1000;
										timer <= 0;
										restart <= 1;
										for (i = 0; i < 5; i = i+1)
											bcd[i] <= 0;
									end
							end
					endcase
				end
		end

endmodule
