`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    17:38:08 11/16/2016 
// Design Name: 
// Module Name:    ms_top 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module ms_top(
	vga_h_sync, vga_v_sync, vga_r0, vga_r1, vga_r2, vga_g0, vga_g1, vga_g2, vga_b0, vga_b1, Sw0,
	St_ce_bar, St_rp_bar, Mt_ce_bar, Mt_St_oe_bar, Mt_St_we_bar,
	Ld0, Ld1, Ld2, Ld3,
	ClkPort, btnU, btnD, btnL, btnR, btnC);
	input ClkPort, btnU, btnD, btnL, btnR, btnC, Sw0;
	output St_ce_bar, St_rp_bar, Mt_ce_bar, Mt_St_oe_bar, Mt_St_we_bar;
	output Ld0, Ld1, Ld2, Ld3;
	output vga_h_sync, vga_v_sync, vga_r0, vga_r1, vga_r2, vga_g0, vga_g1, vga_g2, vga_b0, vga_b1;
	wire vga_h_sync, vga_v_sync, vga_r0, vga_r1, vga_r2, vga_g0, vga_g1, vga_g2, vga_b0, vga_b1, Sw0;
	wire sc_u, sc_d, sc_l, sc_r, sc_c;
	wire reset;
	reg [14:0]	DIV_CLK;
	BUF BUF1 (board_clk, ClkPort); 
	BUF BUF2 (reset, Sw0);
	assign clk = DIV_CLK[1];
	assign sm_clk = DIV_CLK[14];
	wire [3:0] digit;
	wire [4:0] x_quo, y_quo, x_rmd, y_rmd;
	wire b;
	wire start, play, won, lost;
	wire [3:0] actx, acty, curstate;
	wire carry = start || play;
	wire smile = (start || play) && btnC == 0;
	wire shock = (start || play) && btnC;
	
	assign active = (x_quo == actx && y_quo == acty);
	assign Ld0 = start;
	assign Ld1 = play;
	assign Ld2 = won;
	assign Ld3 = lost;

	ms_db db_u(.clk(sm_clk), .reset(reset), .btn(btnU), .carry(carry), .scen(sc_u));
	ms_db db_d(.clk(sm_clk), .reset(reset), .btn(btnD), .carry(carry), .scen(sc_d));
	ms_db db_l(.clk(sm_clk), .reset(reset), .btn(btnL), .carry(carry), .scen(sc_l));
	ms_db db_r(.clk(sm_clk), .reset(reset), .btn(btnR), .carry(carry), .scen(sc_r));
	ms_db db_c(.clk(sm_clk), .reset(reset), .btn(btnC), .carry(carry), .scen(sc_c));
	ms_sm sm(.clk(sm_clk), .reset(reset), .up(sc_u), .down(sc_d), .left(sc_l), .right(sc_r), .click(sc_c), .curx(x_quo), .cury(y_quo),
		.start(start), .play(play), .won(won), .lost(lost), .actx(actx), .acty(acty), .curstate(digit));
	ms_display display(.clk(clk), .reset(reset), .vga_h_sync(vga_h_sync), .vga_v_sync(vga_v_sync),
		.vga_r0(vga_r0), .vga_r1(vga_r1), .vga_r2(vga_r2), .vga_g0(vga_g0), .vga_g1(vga_g1), .vga_g2(vga_g2), .vga_b0(vga_b0), .vga_b1(vga_b1),
		.St_ce_bar(St_ce_bar), .St_rp_bar(St_rp_bar), .Mt_ce_bar(Mt_ce_bar), .Mt_St_oe_bar(Mt_St_oe_bar), .Mt_St_we_bar(Mt_St_we_bar),
		.x_quo(x_quo), .y_quo(y_quo), .x_rmd(x_rmd), .y_rmd(y_rmd),
		.active(active), .b(b), .start(smile), .play(shock), .won(won), .lost(lost), .digit(digit));
	ms_bitmap bitmap(.digit(digit), .x(x_rmd), .y(y_rmd), .b(b));
		
	always @ (posedge board_clk, posedge reset)
	begin
      if (reset)
			DIV_CLK <= 0;
      else
			DIV_CLK <= DIV_CLK + 1'b1;
	end
endmodule
